var Zt = {
    winboxArr : []
    ,now : function () {
        return new Date().getTime();
    }
};
(function(window, Z, $){

    Z.closeWin = function (fn) {
        //堆栈中取出所有win, 循环关闭.
        var winboxArr = this.winboxArr || {};
        var isHas = 0;
        for (var win in winboxArr) {
            isHas = 1;
            winboxArr[win].closeWin();
        }
        if (fn) {
            fn();
        }
        $('#hideForLoginBox').append(Z.loginBox);
    };

    window.closePop = function(){
        Z.closeWin();
    }
    Z.showWin = function (opts) {
        //支持直接调用和new
        var me = this;
        //若直接调用, 只显示一次
        if (!(me instanceof Z.showWin)) {
            opts.showOnce = true;
            var newWin = new me.showWin(opts);
            newWin.initWin(true);
            return;
        }

        if (opts == undefined) {
            opts = {};
        } else if (typeof opts == 'string') {
            opts = {
                htmlStr: opts
            };
        }

        var showOnce = opts.showOnce || false;

        me.onWinBoxShowed = opts.onWinBoxShowed || function () {};
        me.html = opts.htmlStr || '';

        me.initMask = function () {
            if (me.winmask) {
                me.winmask.remove();
            }
            var maskWidth = '100%';
            var maskHeight = $(document).height()+'px';

            var maskArr = ['<div style="width:', maskWidth, ';height:', maskHeight, ';position:absolute;z-index: 998;', 'background:', opts.maskColor || '#FFF', ';opacity:',opts.opacity ||'0.6' ,';top:0;left:0;" class="__mask winbox-mask"></div>'];

            me.winmask = $(maskArr.join(''));
            $('body').append(me.winmask);
        };

        me.closeWin = function (callback) {
            if (me.timer) {
                clearTimeout(me.timer);
                me.timer = null;
            }
            if (showOnce) {
                me.winbox.remove();
                me.winmask.remove();
                //删除win
                delete Z.winboxArr[me.timespam];
            } else {
                me.winbox.hide();
                me.winmask.hide();
            }
            ecomdx.setPopShow(false);//客户端接口
            if (callback) callback();
        };

        me.initWin = function (show) {
            var html = me.html;
            if (typeof html == 'string' && !(/<|>/.test(html))) {
                me.winbox = $(['<div>', html, '</div>'].join(''));
            } else {
                me.winbox = $(html);
            }
            if (showOnce) {
                //这个是为了兼容未添加new方法前,旧代码的Z.winbox调用
                Z.winbox = me.winbox;
            }
            me.winmask = $('');
            me.winbox.hide();
            $('body').append(me.winbox);
            me.winbox.click(function (e) {
                if ($(e.target).hasClass('close')) {
                    me.closeWin(opts.callback);
                    e.preventDefault();
                }
            });
            if (show) {
                me.show();
            }
        };

        me.show = function () {
            if (!opts.noMask) {
                me.initMask();
            }
            me.winbox.show();
            me.initPos();
            ecomdx.setPopShow(true);//客户端接口
            $('.__mask').on('touchmove', function(e){ 
                //prevent native touch activity like scrolling
                e.preventDefault(); 
}           );
            me.onWinBoxShowed.call(this);
            if (opts.autohide) {
                me.timer = setTimeout(function () {
                    me.closeWin();
                }, opts.hidetime || 0);
            }

        };
        me.initPos = function () {
            if (opts.offset) {
                me.winbox.css(opts.offset);
                me.winbox.css({
                    position: 'fixed',
                    zIndex: '999'
                });
                return;
            }
            var boxWidth = me.winbox.width();
            var boxHeight = me.winbox.height();

            me.winbox.css({
                position: 'fixed',
                top: '50%',
                left: '50%',
                margin: '-' + boxHeight / 2 + 'px 0 0 -' + boxWidth / 2 + 'px',
                zIndex: '999'
            });
        };
        
        var timespam = new Date().getTime();
        me.timespam = timespam;
        Z.winboxArr[timespam] = me;
        return me;
    };

    Z.dail = function(phoneNum,name,rcv,url){
        var html =[
            '<div class="wbox">'
            ,'	<div class="wCon">'
            ,'		<div class="wA">'
            ,'			<p>'
            ,'				<span class="tel">',phoneNum,'</span>'
            ,'			</p>'
            ,'			<p class="pop">'
            ,'				<span class="add">',name || '','</span>'
            ,'			</p>'
            ,'		</div>'
            ,'		<div class="wB">'
            ,'			<a href="#">拨号</a>'
            ,'		</div>'
            ,'	</div>'
            ,'</div>'
        ];

        Zt.showWin({
            htmlStr: html.join('')
            ,maskColor : '#828282'
            ,onWinBoxShowed: function(){
                var me = this;
                $('.__mask').on('click',function(e){
                    me.closeWin();
                });
                $('.wB').on('click',function(e){
                    e.preventDefault();
                    
                    ecomdx.call(phoneNum,url);
                })
            }
        });
    };
})(window, Zt, $);

